<Query Kind="Program" />

void Main() {
 var myBaseClass=new MyBaseClass();
 myBaseClass.PublicProperty=1;
 Console.WriteLine($"PublicProperty:{myBaseClass.PublicProperty}");//1 
 //myBaseClass.ProtectedProperty=2; // 編譯錯誤
 myBaseClass.InternalProperty=3;
 Console.WriteLine($"InternalProperty:{myBaseClass.InternalProperty}"); //3
 //myBaseClass.PrivateProtectedProperty=4; // 編譯錯誤
 
 var myDerivedClass=new MyDerivedClass();
 myDerivedClass.ProtectedInternalProperty=5;
 //5
 Console.WriteLine($"ProtectedInternalProperty:{myDerivedClass.ProtectedInternalProperty}");
 myDerivedClass.ExampleMethod();
}

//定義 MyBaseClass 類別
public class MyBaseClass
{
    public int PublicProperty { get; set; }  // 可被任何地方存取
	protected int ProtectedProperty { get; set; }  // 只能被自身及其子類別存取
	internal int InternalProperty { get; set; }  // 只能在同一專案(組件)中存取
	// 只能在內部類別及相同專案內的衍生類別中存取	
	private protected int PrivateProtectedProperty { get; set; }  
}

//定義 MyDerivedClass 類別
public sealed class MyDerivedClass : MyBaseClass
{
    // 在相同專案或任何衍生類別中存取
	protected internal int ProtectedInternalProperty { get; set; }  

    public void ExampleMethod()
    {
        ProtectedProperty = 6;  // 可以在子類別中存取
		PrivateProtectedProperty = 7;  // 可以在相同專案內的子類別中存取
		Console.WriteLine($"ProtectedProperty:{ProtectedProperty}");//6 
	    Console.WriteLine($"PrivateProtectedProperty:{PrivateProtectedProperty}");//7 
    }
}